package com.example.testingNotepad;

import cucumber.api.java.After;
import cucumber.api.java.Before;
import cucumber.api.java.en.Given;
import cucumber.api.java.en.Then;
import cucumber.api.java.en.When;
import cucumber.api.Scenario;
import com.smartbear.cucumber.TestComplete;

public class Steps {
    @Given("^I open Notepad$")
    public void open_notepad() throws Throwable
    {
        World.TC().RunRoutine("Unit1.openNotepad");
    }

    @When("^I type \"(.*)\"$")
    public void type_text(String text) throws Throwable
    {
        World.TC().RunRoutine("Unit1.typeText", text);
    }

    @Then("^I see \"(.*)\" in the Notepad window$")
    public void check_lines(String expected) throws Throwable {
        World.TC().RunRoutine("Unit1.checkText", expected);
    }

    @When("^I start new line$")
    public void new_line() throws Throwable
    {
        World.TC().RunRoutine("Unit1.addNewLine");
    }

    @Then("^I see \"(.*)\" and \"(.*)\" at the separate lines$")
    public void check_two_lines(String expected_1, String expected_2) throws Throwable
    {
        World.TC().RunRoutine("Unit1.checkTwoLines", expected_1, expected_2);
    }

    @Before
    public void before(Scenario scenario)
    {
        World.TC().GetLog().CreateFolder(scenario.getName());
    }

    @After
    public void after()
    {
        World.TC().GetLog().PopFolder();
    }

}

class World {
    public static TestComplete tc;

    public static TestComplete TC() {
        if (tc == null) {

            tc = new TestComplete(
                    // Path to the TestComplete suite
                    "C:\\Work\\Tests\\TestingNotepad\\TestingNotepad.pjs",
                    // The name of the test project
                    "TestingNotepad",
                    // The name of the log
                    "TestingNotepad Log"
            );
            Runtime.getRuntime().addShutdownHook(new Thread() {
                public void run() {
                    try {

                        // Export log
                        World.tc.ExportLog();
                        // Stop playback, after test finishes
                        World.tc.GetIntegration().Stop();
                        // Close TestComplete, after test finishes
                        //World.tc.Quit();

                    } catch (Throwable e) {
                        e.printStackTrace();
                    }
                }
            });
        }
        return tc;
    }
}
